  
  //  eCont.cpp
  //  Created by Kristopher Krasnosky on 7/13/13.
  //  Copyright (c) 2013 Faraway5. All rights reserved.
  
  #include "eCont.h"
  
  #include <SPI.h>         // needed for Arduino versions later than 0018
  #include <Ethernet.h>
  #include <EthernetUdp.h>         // UDP library from: bjoern@cs.stanford.edu 12/30/2008
  
  
  eCont:: eCont(){
    
  }
  
  void eCont:: init(){
  byte mac[] = {  
    0x90, 0xA2, 0xDA, 0x0D, 0xC8, 0x06 };  // set the mac address.  be sure you set it to your board
    IPAddress ip(192, 168, 0, 2);    // set a compatable ip address for your network
    unsigned int localPort = 8888;    // set a port to communicate over
    Ethernet.begin(mac,ip);      // begin the ethernet
    Udp.begin(localPort);      // begin the UDP
  }
  
   void eCont::updateBuffer(){
    int packetSize = Udp.parsePacket();  //  get the packet from the UDP and and store the size
    if(packetSize){   // check to make sure the packet is non zero
       Udp.read(packetBuffer,UDP_TX_PACKET_MAX_SIZE);   // read the packet and store to packet buffer.  Note packet buffer is 
                                                        // a reference parameter so it will be re-writen here.
      Serial.println("Contents:");  // print packet buffer for debuging
      Serial.println(packetBuffer);
    }
  }
  
  String eCont::getBuffer(){
    String val=packetBuffer;    // simply return the buffer
    return val;
  }
  
  String eCont::getCmd(){
    String temp=packetBuffer;    // Cast packetbuffer as a string called temp      
    return temp.substring(0,temp.indexOf(":"));    // search for the colon and return text up to that point
  }
  long eCont::getVal(){
    String temp=packetBuffer;   // Cast packetbuffer as a string called temp
    return extract(packetBuffer, temp.indexOf(":")+1,temp.length());  //  extract the interger from the just after the colon to the end of the string.
  }
  
  
  void eCont::sendCmd(String cmd, long val){
      char charBuf[50];      // create a character buffer you may need a larger one depending on the size of your packets
      String s=cmd+String(val);    //append the long int to the string 
      s.toCharArray(charBuf, 50);  //  convert the string s to a character array so we can send it over the udp
      Udp.beginPacket(Udp.remoteIP(), Udp.remotePort()); // begin your packet on on the remote ip and port
      Udp.write(charBuf);    // send the character buffer
      Udp.endPacket();    // end the packet and send
  }
  
  /**
   **    Private Functions
   **/
   
   
  
  int eCont::extract(char *input, int from, int length){
    char temp[length+1];  // create a temporary character buffer
    strncpy(temp, input+from, length);   //  create an arrary of characters
    return atoi(temp);  //  return an interger
  }
