  //  eCont.h
  //  eCont is a class to easily recieve and parse commands sent from the corresponding Cocoa Applicaiton
  //  Created by Kristopher Krasnosky on 7/13/13.
  //  Copyright (c) 2013 Faraway5. All rights reserved.
  
  #ifndef car_h
  #define car_h
  
  #include <SPI.h>         // needed for Arduino versions later than 0018
  #include <Ethernet.h>
  #include <EthernetUdp.h>         // UDP library from: bjoern@cs.stanford.edu 12/30/2008
  
  class eCont{
    public:
    eCont();  // constructor  not used at this point
    void init();  // initialize the 
    void updateBuffer();  // update the internal buffer
    String getBuffer();   // return the buffer as a string
    String getCmd();    // return the recieved command as a string
    long getVal();    // return the value of the command as a long int
    void sendCmd(String cmd, long val);   // format a command and send it over UDP
    
    private:
    
    // data storage
    char packetBuffer[UDP_TX_PACKET_MAX_SIZE]; //buffer to hold incoming packet,
    unsigned int localPort; 
    EthernetUDP Udp;
    
    // functions
    int extract(char *input, int from, int length);  // convert a section of a string to an int
    // usefull for converting command values to ints that can be used
    
  };
  
  
  #endif
